SistemaERP/Controllers/CuentaController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Logica;
using Datos;
using Entidad.Estados;
using Entidad;
using Microsoft.Reporting.WebForms;

namespace SistemaERP.Controllers
{
    public class CuentaController : Controller
    {

        private LCuenta logica = LCuenta.Logica.LCuenta;
        public ActionResult Index()
        {


            return View();
        }

        [HttpPost]
        public ActionResult ListarCuenta()
        {

            /* Usuario usuario = (Usuario)Session["Usuario"];
             Empresa empresa = (Empresa)Session["Empresa"];



             return View();*/

            try
            {
                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];

                List<ECuenta> cuentas = new List<ECuenta>();
                cuentas = logica.listarCuentas(usuario.idUsuario, empresa.idEmpresa);

                /*
                 *Registrar hijos
                 * 
                 * Cuenta cuenta = new Cuenta()
                 {
                     Nombre = "prueba registro 2",
                     Codigo = "",
                     Nivel = 0,
                     TipoCuenta = "detalle",
                     IdUsuario = usuario.idUsuario,
                     IdEmpresa = empresa.idEmpresa,
                     IdCuentaPadre = 1


                 };

                 logica.Registro(cuenta, 1, 0);*/

                /*    Cuenta cuenta = new Cuenta()
                    {
                        Nombre = "prueba registro 3",
                        Codigo = "",
                        Nivel = 0,
                        TipoCuenta = "detalle",
                        IdUsuario = usuario.idUsuario,
                        IdEmpresa = empresa.idEmpresa,
                        IdCuentaPadre = 3


                    };
                    // 0 hijo
                    // 1 padre
                    logica.Registro(cuenta, 3, 0);*/

                return Json(new
                {
                    Cuentas = cuentas

                });

            }
            catch (MensageException ex)
            {
                string mensaje = ex.Message.Replace("'", "");
                ViewBag.Mensaje = mensaje;
                return JavaScript("MostrarMensaje('" + mensaje + "');");
            }
            catch (Exception ex)
            {

                return JavaScript("MostrarMensaje('Ha ocurrido un error');");
            }

        }






        [HttpPost]
        public ActionResult ObtenerCuenta(long idcuenta)
        {

            /* Usuario usuario = (Usuario)Session["Usuario"];
             Empresa empresa = (Empresa)Session["Empresa"];



             return View();*/

            try
            {
                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];

                //List<ECuenta> cuentas = new List<ECuenta>();
                var entidad = logica.obtenerCuenta(idcuenta);


                return Json(new
                {
                    Nombre = entidad.Nombre

                });

            }
            catch (MensageException ex)
            {
                string mensaje = ex.Message.Replace("'", "");
                ViewBag.Mensaje = mensaje;
                return JavaScript("MostrarMensaje('" + mensaje + "');");
            }
            catch (Exception ex)
            {

                return JavaScript("MostrarMensaje('Ha ocurrido un error');");
            }

        }




        [HttpPost]
        public ActionResult Registro(string nombre, long idCuenta, long idPadre)
        {

            try
            {





                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];



                if (idPadre == 0)
                {
                    //hijo 0
                    Cuenta cuenta = new Cuenta()
                    {
                        Nombre = nombre,
                        Codigo = "",
                        Nivel = 0,
                        TipoDeCuenta = (int)TipoCuenta.Global,
                        IdUsuario = usuario.idUsuario,
                        IdEmpresa = empresa.idEmpresa,
                        IdCuentaPadre = idCuenta


                    };
                    logica.Registro(cuenta, idCuenta, 0);
                }

                else if (idPadre == 1)
                {
                    //padre 1
                    Cuenta cuenta = new Cuenta()
                    {
                        Nombre = nombre,
                        Codigo = "",
                        Nivel = 0,
                        TipoDeCuenta = (int)TipoCuenta.Global,
                        IdUsuario = usuario.idUsuario,
                        IdEmpresa = empresa.idEmpresa,



                    };
                    logica.Registro(cuenta, 0, 1);
                }


                // 0 hijo
                // 1 padre


                //List<Empresa> empresas = new List<Empresa>();
                // empresas = logica.listarEmpresa(usuario.idUsuario);
                // return PartialView("_ListaEmpresa", empresas);
                return JavaScript("MostrarMensajeExito('Registro Exitoso');");
            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

        }


        [HttpPost]
        public ActionResult Editar(string nombre, long idCuenta)
        {

            try
            {





                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];



                logica.ModificarCuenta(idCuenta, nombre, empresa.idEmpresa);

                // 0 hijo
                // 1 padre


                //List<Empresa> empresas = new List<Empresa>();
                // empresas = logica.listarEmpresa(usuario.idUsuario);
                // return PartialView("_ListaEmpresa", empresas);
                return JavaScript("MostrarMensajeExitoEditar('Modificacion Exitoso');");
            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

        }


        [HttpPost]
        public ActionResult Eliminar(long idCuenta)
        {

            try
            {





                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];



                logica.EliminarCuenta(idCuenta);

                // 0 hijo
                // 1 padre


                //List<Empresa> empresas = new List<Empresa>();
                // empresas = logica.listarEmpresa(usuario.idUsuario);
                // return PartialView("_ListaEmpresa", empresas);
                return JavaScript("MostrarMensajeEliminacion('Eliminación Exitosa');");
            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

        }



        public ActionResult ReporteCuenta()
        {
            try
            {


                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];
              //  Gestion gestion = (Gestion)Session["Gestion"];
                List<ECuenta> cuentas = new List<ECuenta>();
                cuentas = logica.listarCuentasReporte(usuario.idUsuario, empresa.idEmpresa);

                List<ERDatosBasicoCuenta> datosBasico = new List<ERDatosBasicoCuenta>();
                datosBasico = logica.ReporteDatosBasicoCuenta(usuario.Usuario1, empresa.Nombre);
                ReportViewer viewer = new ReportViewer();
                viewer.AsyncRendering = false;
                viewer.SizeToReportContent = true;

                ReportDataSource rp = new ReportDataSource("DSReporteCuenta", cuentas);
                ReportDataSource rb = new ReportDataSource("DSReporteBasicoCuenta", datosBasico);
                viewer.LocalReport.ReportPath = Server.MapPath("~/Reportes/ReporteCuenta.rdlc");
                viewer.LocalReport.DataSources.Clear();
                viewer.LocalReport.DataSources.Add(rp);
                viewer.LocalReport.DataSources.Add(rb);

                viewer.LocalReport.Refresh();

                ViewBag.ReporteCuenta = viewer;


                return View("ReporteCuenta");
            }
            catch (MensageException ex)
            {
                string mensaje = ex.Message.Replace("'", "");
                ViewBag.Mensaje = mensaje;
                return JavaScript("MostrarMensaje('" + mensaje + "');");
            }
            catch (Exception ex)
            {

                return JavaScript("MostrarMensaje('Ha ocurrido un error');");
            }

        }

        public ActionResult CuentaIntegracion()
        {


            Usuario usuario = (Usuario)Session["Usuario"];
            Empresa empresa = (Empresa)Session["Empresa"];

            ViewBag.CuentasDetalle = logica.listarCuentaDetalle(empresa.idEmpresa);



            return View(LEmpresa.Logica.LEmpresa.obtenerEmpresa(empresa.idEmpresa));
        }

        [HttpPost]
        public ActionResult RegistroCuentaIntegracion(int integracion,long IdCaja, long IdCreditoFiscal, long IdDebitoFiscal, long IdCompras, long IdVentas,long IdIt, long IdItPagar )
        {

            try
            {

SistemaERP/Views/Cuenta/ReporteCuenta.cshtml
@using ReportViewerForMvc;
@using Datos;
@using Entidad;
@model List<Periodo>
@{
    ViewBag.Title = "Reporte Cuenta";
    Gestion gestion = ESesion.ObtenerGestion<Gestion>(Session["Gestion"]);
    Layout = "~/Views/Shared/_Layout.cshtml";

}
@section EtiquetaHead
    {



    <link href="@Url.Content("~/Content/adminLte/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css")" rel="stylesheet" />
    <link href="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/css/responsive.bootstrap4.min.css")" rel="stylesheet" />


    <link href="@Url.Content("~/Content/bootstrap-datepicker/css/bootstrap-datepicker.css")" rel="stylesheet" />
    <link href="@Url.Content("~/Content/bootstrap-datepicker/css/bootstrap-datepicker3.css")" rel="stylesheet" />

    @* pdf <link href="//cdn.datatables.net/buttons/1.5.6/css/buttons.bootstrap4.min.css" rel="stylesheet">
    *@

    @*<link href="@Url.Content("~/Content/adminLte/plugins1/datatables/datatables.min.css")" rel="stylesheet" />
        <link href="@Url.Content("~/Content/adminLte/plugins1/datatables/plugins/bootstrap/datatables.bootstrap.css")" rel="stylesheet" />
    *@
}



<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">



        </div>
    </div><!-- /.container-fluid -->
</section>

<section class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <!-- Default box -->
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">
                          
                        </h3>

                    </div>
                    <div class="card-body">


                        <div class="row ">
                            <div class="form-group">
                                <a href="@Url.Action("Index", "Cuenta")" class="btn btn-secondary" style="margin-left:10px;"> <i class=" fas fa-undo-alt"></i>  </a>
                            </div>


                        </div>
                        <div class="form-group">
                            @Html.ReportViewer(ViewBag.ReporteCuenta as Microsoft.Reporting.WebForms.ReportViewer, new { style = "width: 900px; height:900px " })

                        </div>




                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">

                    </div>
                    <!-- /.card-footer-->
                </div>
                <!-- /.card -->
            </div>
        </div>
    </div>
</section>


@section Scripts{


    <script src="@Url.Content("~/Content/adminLte/plugins/datatables/jquery.dataTables.min.js")"></script>

    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>

    <script src="@Url.Content("~/Content/bootstrap-datepicker/js/bootstrap-datepicker.min.js")"></script>

    @* Buttons pdf <script src="//cdn.datatables.net/buttons/1.5.6/js/dataTables.buttons.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.bootstrap4.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/pdfmake.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/vfs_fonts.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.html5.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.print.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.colVis.min.js"></script>*@


    @*<script src="@Url.Content("~/Scripts/metronic/global/scripts/datatable.js")"></script>

        <script src="@Url.Content("~/Content/adminLte/plugins1/datatables/datatables.min.js")"></script>
        <script src="@Url.Content("~/Content/adminLte/plugins1/datatables/plugins/bootstrap/datatables.bootstrap.js")"></script>
    *@
    <script type="text/javascript">




        $(document).ready(function () {
          

        });

        function redireccionar(url) {
            window.location = url;
        }







         
        

        function MostrarMensaje(msj) {
                $("#modalEliminar").modal('hide');


                 $(document).Toasts('create', {
                        class: ' bg-danger',
                        title: "Alerta",
                        autohide: true,
                        delay: 10000,
                        body: msj
                    });
        }


         


       
      




    </script>

}